<template>
  <q-layout view="hHh LpR fFf">
    <HeaderComponent
      :title="title"
      :langOptions="langOptions"
      @update:drawerLeft="toggleDrawer"
      @update:lang="changeLanguage"
    />

    <Drawer
      :drawerLeft="drawerLeft"
      :userCover="userCover"
      :userAvatar="userAvatar"
      :fullName="fullName"
      :userId="userId"
      :isLoggedIn="isLoggedIn"
    />

    <q-page-container>
      <!-- Содержимое основного контейнера -->
      <router-view />
    </q-page-container>

    <LoginDialog v-model="showLoginDialog" />
    <LogoutDialog v-model="showLogoutDialog" @confirm-logout="performLogout" />

    <!-- Здесь можно добавить Footer, если необходимо -->
  </q-layout>
</template>

<script lang="ts">
import { defineComponent, ref, computed } from 'vue';
import HeaderComponent from '../components/mainLayout/HeaderComponent.vue';
import Drawer from '../components/mainLayout/DrawerComponent.vue';
import LoginDialog from '../components/mainLayout/LoginDialog.vue';
import LogoutDialog from '../components/mainLayout/LogoutDialog.vue';

export default defineComponent({
  name: 'MainLayout',
  components: { HeaderComponent, Drawer, LoginDialog, LogoutDialog },
  setup() {
    const drawerLeft = ref(false);
    const showLoginDialog = ref(false);
    const showLogoutDialog = ref(false);
    const langOptions = ref(['EN', 'RU']);
    const title = ref('My Application'); // Название вашего приложения
    // Дополнительные данные пользователя
    const userCover = ref('path/to/cover.jpg');
    const userAvatar = ref('path/to/avatar.jpg');
    const fullName = ref('John Doe');
    const userId = ref('12345');
    const isLoggedIn = ref(true); // или управление через состояние аутентификации

    const toggleDrawer = () => {
      drawerLeft.value = !drawerLeft.value;
    };

    const changeLanguage = (newLang: string) => {
      // Логика смены языка
      console.log('Language changed to:', newLang);
    };

    const performLogout = () => {
      // Логика выхода из системы
      console.log('User logged out');
      isLoggedIn.value = false; // Обновите это состояние в соответствии с вашей логикой аутентификации
    };

    return {
      drawerLeft,
      showLoginDialog,
      showLogoutDialog,
      langOptions,
      title,
      userCover,
      userAvatar,
      fullName,
      userId,
      isLoggedIn,
      toggleDrawer,
      changeLanguage,
      performLogout,
    };
  },
});
</script>

<style scoped>
/* Стили для MainLayout, если необходимы */
</style>
